commit 358e7de5e1efba5a3c5121a1edc6da99d2a8243f
Author: skenneweg <skenneweg@techfak.uni-bielefeld.de>
Date:   Mon Jun 29 19:43:36 2020 +0200

    Wrote hello world functions for all three node functions (loop, shutdown, setup) for testing.

diff --git a/apps/HelloWorld/helloworld.c b/apps/HelloWorld/helloworld.c
index 26649c6..ca7fe74 100644
--- a/apps/HelloWorld/helloworld.c
+++ b/apps/HelloWorld/helloworld.c
@@ -20,13 +20,26 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 #pragma message "Hello World! (.c)"
 
-urt_osEventMask_t hello(urt_node_t* node, urt_osEventMask_t events, void* arg)
+//Parameter (und rückgabewert) immer anpassen an shutdown, loop, setup
+void helloShutdown(urt_node_t* node, urt_status_t cause, void* arg)
 {
-    urtPrintf("Hello World!\n");
-    return URT_EVENTMASK_ALL;
+    urtPrintf("Hello World shutdown!\n");
+    return;
+}
+
+urt_osEventMask_t helloSetup(urt_node_t* node, void* arg)
+{
+  urtPrintf("Hello World setup!\n");
+  return URT_EVENTMASK_ALL;
+}
+
+urt_osEventMask_t helloLoop(urt_node_t* node, urt_osEventMask_t events, void* arg)
+{
+  urtPrintf("Hello World loop!\n");
+  return URT_EVENTMASK_ALL;
 }
 
 void helloWorldInit(urt_node_t* node, urt_osThread_t* thread)
 {
-    urtNodeInit(node, thread, URT_THREAD_PRIO_LOW_MIN, NULL, NULL, &hello, NULL, NULL, NULL);
+    urtNodeInit(node, thread, URT_THREAD_PRIO_LOW_MIN, &helloSetup, NULL, &helloLoop, NULL, &helloShutdown, NULL);
 }
diff --git a/apps/HelloWorld/helloworld.h b/apps/HelloWorld/helloworld.h
index ecce232..e9ca19f 100644
--- a/apps/HelloWorld/helloworld.h
+++ b/apps/HelloWorld/helloworld.h
@@ -27,7 +27,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 extern "C" {
 #endif /* defined(__cplusplus) */
 
-urt_osEventMask_t hello(urt_node_t* node, urt_osEventMask_t events, void* arg);
+void helloShutdown(urt_node_t* node, urt_status_t cause, void* arg);
+urt_osEventMask_t helloSetup(urt_node_t* node, void* arg);
+urt_osEventMask_t helloLoop(urt_node_t* node, urt_osEventMask_t events, void* arg);
 void helloWorldInit(urt_node_t* node, urt_osThread_t* thread);
 
 #if defined(__cplusplus)
diff --git a/configurations/HelloWorld/modules/NUCLEO-F401RE/mainincludes.hpp b/configurations/HelloWorld/modules/NUCLEO-F401RE/mainincludes.hpp
index d281bf3..5ce4696 100644
--- a/configurations/HelloWorld/modules/NUCLEO-F401RE/mainincludes.hpp
+++ b/configurations/HelloWorld/modules/NUCLEO-F401RE/mainincludes.hpp
@@ -22,15 +22,15 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #include <urtware.h>
 #include <helloworld.h>
 
-static URT_THREAD_MEMORY(hellosvenja_thread, 256);
-static URT_THREAD_MEMORY(hellothomas_thread, 256);
+static URT_THREAD_MEMORY(hellosvenja_thread, 512);
+//static URT_THREAD_MEMORY(hellothomas_thread, 256);
 static urt_node_t hellosvenja_node;
-static urt_node_t hellothomas_node;
+//static urt_node_t hellothomas_node;
 
-#define AMIROOS_CFG_MAIN_INIT_HOOK_4() {                                \
-    urtCoreInit();                                                      \
+#define AMIROOS_CFG_MAIN_INIT_HOOK_3() {                                                \
+    urtCoreInit();                                                                      \
     helloWorldInit(&hellosvenja_node, (urt_osThread_t*)hellosvenja_thread);             \
-    helloWorldInit(&hellothomas_node, (urt_osThread_t*)hellothomas_thread);             \
+    urtCoreStartNodes();                                                                \
 }
 
 
diff --git a/middleware/apps_urtosal.c b/middleware/apps_urtosal.c
index 5d574b8..ade5e4c 100644
--- a/middleware/apps_urtosal.c
+++ b/middleware/apps_urtosal.c
@@ -136,6 +136,11 @@ void urtThreadTerminate(urt_osThread_t* thread, urt_osThreadTerminateSignal_t si
   }
 }
 
+bool urtThreadShouldTerminate(void)
+{
+    return true;
+}
+
 urt_osThreadState_t urtThreadGetState(urt_osThread_t* thread)
 {
   aosDbgCheck(thread != NULL);
diff --git a/middleware/uRtWare b/middleware/uRtWare
index 4ea18a0..408b49c 160000
--- a/middleware/uRtWare
+++ b/middleware/uRtWare
@@ -1 +1 @@
-Subproject commit 4ea18a07d5e39ca20993e9b7ec61f20f1777757b
+Subproject commit 408b49ced4cef056194315f3d612d1fd339bcccc