commit 414a351656b84f450ccb076eede6de8ed281c1e6
Author: Simon Schulz <sschulz@cit-ec.uni-bielefeld.de>
Date:   Wed Jan 6 10:52:11 2016 +0100

    dropped rsb support due to maintanance overload

diff --git a/CMakeLists.txt b/CMakeLists.txt
index fb9887e..ce80a1c 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -3,59 +3,15 @@ project(humotion)
 
 set(ENV{ROS_LANG_DISABLE} "genjava")
 
-
 set(ROS_BUILD_TYPE Debug)
 
-
-#######################################
-#allow forced disable of RSB
-option(IGNORE_RSB "IGNORE_RSB" OFF)
-
-#######################################
-# check if we have RSB support:
-IF (IGNORE_RSB)
-    MESSAGE(INFO "RSB disabled per command line flag IGNORE_RSB")
-ELSE (IGNORE_RSB)
-FIND_PACKAGE(RSB 0.11)
-IF (RSB_FOUND)
-    #RSB
-    SET(CMAKE_INSTALL_RPATH "\$ORIGIN/../lib:\$ORIGIN/")
-    FIND_PACKAGE(RSC 0.11 REQUIRED)
-    FIND_PACKAGE(RSB 0.11 REQUIRED)
-    #RST
-    FIND_PACKAGE(RST REQUIRED COMPONENTS sandbox)
-    INCLUDE_DIRECTORIES(BEFORE SYSTEM ${RST_INCLUDE_DIRS})
-    ADD_DEFINITIONS(${RST_CFLAGS} ${RSTSANDBOX_CFLAGS})
-
-    INCLUDE_DIRECTORIES(BEFORE SYSTEM ${RSB_INCLUDE_DIRS})
-    LIST(INSERT CMAKE_MODULE_PATH 0 ${RSC_CMAKE_MODULE_PATH})
-    #RSB
-    SET(CMAKE_INSTALL_RPATH "\$ORIGIN/../lib:\$ORIGIN/")
-    FIND_PACKAGE(RSC 0.11 REQUIRED)
-    FIND_PACKAGE(RSB 0.11 REQUIRED)
-    #RST
-    FIND_PACKAGE(RST REQUIRED COMPONENTS sandbox)
-    INCLUDE_DIRECTORIES(BEFORE SYSTEM ${RST_INCLUDE_DIRS})
-    ADD_DEFINITIONS(${RST_CFLAGS} ${RSTSANDBOX_CFLAGS})
-
-    INCLUDE_DIRECTORIES(BEFORE SYSTEM ${RSB_INCLUDE_DIRS})
-    LIST(INSERT CMAKE_MODULE_PATH 0 ${RSC_CMAKE_MODULE_PATH})
-
-    message(STATUS "RSB Support is ON")
-    add_definitions(-DRSB_SUPPORT=1)
-ENDIF (RSB_FOUND)
-ENDIF(IGNORE_RSB)
-
 ################################################################
 # check for ROS support:
 find_package(catkin REQUIRED COMPONENTS roscpp std_msgs sensor_msgs message_generation genmsg)
-IF (catkin_FOUND)
-    set(ROS_FOUND 1)
-    message(STATUS "ROS Support is ON")
-    add_definitions(-DROS_SUPPORT=1)
+IF (NOT catkin_FOUND)
+  MESSAGE(FATAL_ERROR "Error: could not find ROS middleware!")
 ENDIF (catkin_FOUND)
 
-
 INCLUDE(FindPkgConfig)
 
 ##libreflexxes
@@ -69,10 +25,6 @@ ELSE ()
   ENDIF ()
 ENDIF ()
 
-IF (NOT catkin_FOUND AND NOT RSB_FOUND)
-  message(FATAL_ERROR "Error: could neither find RSB or ROS middleware!")
-ENDIF ()
-
 
 SET(REFLEXXES_LIBRARY_DIRS "${REFLEXXES_PREFIX}/lib")
 SET(REFLEXXES_INCLUDE_DIRS "${REFLEXXES_PREFIX}/include")
@@ -81,49 +33,46 @@ SET(REFLEXXES_INCLUDE_DIRS "${REFLEXXES_PREFIX}/include")
 find_library(REFLEXXES_LIBRARY NAMES ${REFLEXXES_LIBRARIES} HINTS ${REFLEXXES_LIBRARY_DIRS})
 
 MESSAGE("-- using libReflexxesTypeII version ${REFLEXXES_VERSION} from ${REFLEXXES_INCLUDE_DIRS} and ${REFLEXXES_LIBRARY_DIRS}")
-MESSAGE("-- will ink against ${REFLEXXES_LIBRARY}")
+MESSAGE("-- will link against ${REFLEXXES_LIBRARY}")
 
 set(CMAKE_CXX_FLAGS "-g -Wall")
 add_definitions ("-Wall")
 
+#######################################
+## Declare ROS messages and services ##
+#######################################
 
-IF (catkin_FOUND)
-    #######################################
-    ## Declare ROS messages and services ##
-    #######################################
-
-    add_message_files(
-            FILES
-            gaze.msg
-            position_lcr.msg
-            mouth.msg
-    )
-
-    ## Generate added messages and services with any dependencies listed here
-    generate_messages(
-            DEPENDENCIES
-            std_msgs
-            humotion
-    )
-
-
-    #
-    ###################################
-    ## catkin specific configuration ##
-    ###################################
-    ## The catkin_package macro generates cmake config files for your package
-    ## Declare things to be passed to dependent projects
-    ## INCLUDE_DIRS: uncomment this if you package contains header files
-    ## LIBRARIES: libraries you create in this project that dependent projects also need
-    ## CATKIN_DEPENDS: catkin_packages dependent projects also need
-    ## DEPENDS: system dependencies of this project that dependent projects also need
-    catkin_package(
-        INCLUDE_DIRS include
-        LIBRARIES humotion
-        #CATKIN_DEPENDS message_runtime
-        #DEPENDS system_lib
-    )
-ENDIF (catkin_FOUND)
+add_message_files(
+        FILES
+        gaze.msg
+        position_lcr.msg
+        mouth.msg
+)
+
+## Generate added messages and services with any dependencies listed here
+generate_messages(
+        DEPENDENCIES
+        std_msgs
+        humotion
+)
+
+
+#
+###################################
+## catkin specific configuration ##
+###################################
+## The catkin_package macro generates cmake config files for your package
+## Declare things to be passed to dependent projects
+## INCLUDE_DIRS: uncomment this if you package contains header files
+## LIBRARIES: libraries you create in this project that dependent projects also need
+## CATKIN_DEPENDS: catkin_packages dependent projects also need
+## DEPENDS: system dependencies of this project that dependent projects also need
+catkin_package(
+    INCLUDE_DIRS include
+    LIBRARIES humotion
+    #CATKIN_DEPENDS message_runtime
+    #DEPENDS system_lib
+)
 
 ###########
 ## Build ##
@@ -153,12 +102,10 @@ add_library(humotion
     src/client/client.cpp
     src/client/middleware.cpp
     src/client/middleware_ros.cpp
-    src/client/middleware_rsb.cpp
 
     src/server/server.cpp
     src/server/middleware.cpp
     src/server/middleware_ros.cpp
-    src/server/middleware_rsb.cpp
 
     src/server/controller.cpp
     src/server/joint_interface.cpp
@@ -177,18 +124,15 @@ add_library(humotion
 
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
 
-
 ## Add cmake target dependencies of the executable/library
 ## as an example, message headers may need to be generated before nodes
 add_dependencies(humotion ${catkin_EXPORTED_TARGETS} humotion_gencpp)
 
 ## Specify libraries to link a library or executable target against
 target_link_libraries(humotion
-			${Boost_LIBRARIES}
-			${catkin_LIBRARIES}
-			${REFLEXXES_LIBRARY}
-			${RST_LIBRARIES}
-			${RSB_LIBRARIES}
+    ${Boost_LIBRARIES}
+    ${catkin_LIBRARIES}
+    ${REFLEXXES_LIBRARY}
 )
 
 set_property(TARGET humotion PROPERTY INSTALL_RPATH_USE_LINK_PATH TRUE)
@@ -208,38 +152,32 @@ set_property(TARGET humotion PROPERTY INSTALL_RPATH_USE_LINK_PATH TRUE)
 # )
 
 ## Mark executables and/or libraries for installation
-IF (catkin_FOUND)
-    install(TARGETS humotion
-        ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
-        LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
-        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
-    )
-    ## Mark cpp header files for installation
-    install(DIRECTORY include/humotion/
-        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
-    )
-ENDIF (catkin_FOUND)
-
+install(TARGETS humotion
+    ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
+    LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
+    RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
+)
+## Mark cpp header files for installation
+install(DIRECTORY include/humotion/
+    DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
+)
 
 #############
 ## Testing ##
 #############
-IF (catkin_FOUND)
-    ## Add gtest based cpp test target and link libraries
-    catkin_add_gtest(${PROJECT_NAME}-test-server test/server.cpp)
-    if(TARGET ${PROJECT_NAME}-test-server)
-    target_link_libraries(${PROJECT_NAME}-test-server ${PROJECT_NAME})
-    endif()
-    catkin_add_gtest(${PROJECT_NAME}-test-client test/client.cpp)
-    if(TARGET ${PROJECT_NAME}-test-client)
-    target_link_libraries(${PROJECT_NAME}-test-client ${PROJECT_NAME})
-    endif()
-    catkin_add_gtest(${PROJECT_NAME}-test-timestamp test/timestamp.cpp)
-    if(TARGET ${PROJECT_NAME}-test-timestamp)
-    target_link_libraries(${PROJECT_NAME}-test-timestamp ${PROJECT_NAME})
-    endif()
-ENDIF (catkin_FOUND)
-
+## Add gtest based cpp test target and link libraries
+catkin_add_gtest(${PROJECT_NAME}-test-server test/server.cpp)
+if(TARGET ${PROJECT_NAME}-test-server)
+target_link_libraries(${PROJECT_NAME}-test-server ${PROJECT_NAME})
+endif()
+catkin_add_gtest(${PROJECT_NAME}-test-client test/client.cpp)
+if(TARGET ${PROJECT_NAME}-test-client)
+target_link_libraries(${PROJECT_NAME}-test-client ${PROJECT_NAME})
+endif()
+catkin_add_gtest(${PROJECT_NAME}-test-timestamp test/timestamp.cpp)
+if(TARGET ${PROJECT_NAME}-test-timestamp)
+target_link_libraries(${PROJECT_NAME}-test-timestamp ${PROJECT_NAME})
+endif()
 
 ### Add folders to be run by python nosetests
 # catkin_add_nosetests(test)