commit 426ce07caf672309c173eeea7763da7dfa4be010
Author: Andre Raming <araming@techfak.uni-bielefeld.de>
Date:   Wed Apr 24 11:40:36 2019 +0200

    vl53l0x with submodul

diff --git a/modules/PowerManagement_1-2/module.c b/modules/PowerManagement_1-2/module.c
index 99c4581..4af94a8 100644
--- a/modules/PowerManagement_1-2/module.c
+++ b/modules/PowerManagement_1-2/module.c
@@ -717,7 +717,7 @@ VL53L0XDriver moduleLldProximity1 = {
             },
             /* VL53L0X_HistogramMeasurementData_t */
             {
-                /* HistogramData */ 0,
+                /* HistogramData */ {0},
                 /* HistogramType */ 0,
                 /* FirstBin */ 0,
                 /* BufferSize */ 0,
@@ -774,7 +774,7 @@ VL53L0XDriver moduleLldProximity1 = {
         /* I²C address */ VL53L0X_LLD_I2C_ADDR,
         /* COMM TYPE*/ 1,
         /* COMM SPEED*/ 1,
-    },
+    }
 };
 
 VL53L0XDriver moduleLldProximity2 = {
@@ -879,7 +879,7 @@ VL53L0XDriver moduleLldProximity2 = {
         /* I²C address */ VL53L0X_LLD_I2C_ADDR,
         /* COMM TYPE*/ 1,
         /* COMM SPEED*/ 1,
-    },
+    }
 };
 
 
@@ -1745,7 +1745,6 @@ static int _utShellCmdCb_AlldVL53L0X(BaseSequentialStream* stream, int argc, cha
           // interrupt edge register IE2.2 with falling edge (from HIGH to LOW) == 00100000 on adress 64h
           status |= pcal6524_lld_write_reg(mux1, PCAL6524_LLD_CMD_INTERRUPTEDGE_P2A, 0x20, ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->timeout);
 
-
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->vl53d = &moduleLldProximity1;
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->evtflags = MODULE_OS_IOEVENTFLAGS_IRINT1;
           //set GPIO extender
@@ -1760,8 +1759,6 @@ static int _utShellCmdCb_AlldVL53L0X(BaseSequentialStream* stream, int argc, cha
           // interrupt edge register IE2.1 with falling edge (from HIGH to LOW) == 00001000 on adress 64h
           status |= pcal6524_lld_write_reg(mux1, PCAL6524_LLD_CMD_INTERRUPTEDGE_P2A, 0x8, ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->timeout);
 
-
-
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->vl53d = &moduleLldProximity1;
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->evtflags = MODULE_OS_IOEVENTFLAGS_IRINT1;
           //set GPIO extender
@@ -1793,7 +1790,6 @@ static int _utShellCmdCb_AlldVL53L0X(BaseSequentialStream* stream, int argc, cha
           status |= pcal6524_lld_write_reg(mux1, PCAL6524_LLD_CMD_INTERRUPTEDGE_P1B, 0x80, ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->timeout);
 
 
-
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->vl53d = &moduleLldProximity1;
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->evtflags = MODULE_OS_IOEVENTFLAGS_IRINT1;
           //set GPIO extender
@@ -1914,7 +1910,6 @@ static int _utShellCmdCb_AlldVL53L0X(BaseSequentialStream* stream, int argc, cha
           status |= pcal6524_lld_write_reg(mux2, PCAL6524_LLD_CMD_INTERRUPTEDGE_P2A, 0x80, ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->timeout);
 
 
-
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->vl53d = &moduleLldProximity2;
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->evtflags = MODULE_OS_IOEVENTFLAGS_IRINT2;
           //set GPIO extender
@@ -1945,7 +1940,6 @@ static int _utShellCmdCb_AlldVL53L0X(BaseSequentialStream* stream, int argc, cha
           status |= pcal6524_lld_write_reg(mux2, PCAL6524_LLD_CMD_INTERRUPTEDGE_P2A, 0x8, ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->timeout);
 
 
-
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->vl53d = &moduleLldProximity2;
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->evtflags = MODULE_OS_IOEVENTFLAGS_IRINT2;
           //set GPIO extender
@@ -1977,7 +1971,6 @@ static int _utShellCmdCb_AlldVL53L0X(BaseSequentialStream* stream, int argc, cha
           status |= pcal6524_lld_write_reg(mux2, PCAL6524_LLD_CMD_INTERRUPTEDGE_P1B, 0x80, ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->timeout);
 
 
-
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->vl53d = &moduleLldProximity2;
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->evtflags = MODULE_OS_IOEVENTFLAGS_IRINT2;
           //set GPIO extender
@@ -2009,7 +2002,6 @@ static int _utShellCmdCb_AlldVL53L0X(BaseSequentialStream* stream, int argc, cha
           status |= pcal6524_lld_write_reg(mux2, PCAL6524_LLD_CMD_INTERRUPTEDGE_P1B, 0x8, ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->timeout);
 
 
-
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->vl53d = &moduleLldProximity2;
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->evtflags = MODULE_OS_IOEVENTFLAGS_IRINT2;
           //set GPIO extender
@@ -2025,6 +2017,7 @@ static int _utShellCmdCb_AlldVL53L0X(BaseSequentialStream* stream, int argc, cha
           // interrupt edge register IE1.4 with falling edge (from HIGH to LOW) == 00 00 00 10 on adress 63h
           status |= pcal6524_lld_write_reg(mux2, PCAL6524_LLD_CMD_INTERRUPTEDGE_P1B, 0x2, ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->timeout);
 
+
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->vl53d = &moduleLldProximity2;
           ((ut_vl53l0xdata_t*)moduleUtAlldVl53l0x.data)->evtflags = MODULE_OS_IOEVENTFLAGS_IRINT2;
           //set GPIO extender
diff --git a/periphery-lld/AMiRo-LLD b/periphery-lld/AMiRo-LLD
index 7021191..6ebebd4 160000
--- a/periphery-lld/AMiRo-LLD
+++ b/periphery-lld/AMiRo-LLD
@@ -1 +1 @@
-Subproject commit 7021191ecfc8747358c1ea4b331b95ceb8908716
+Subproject commit 6ebebd4d7aa9aa16a2322c41de61d41fd62140d4